diff -urN gcc-3.0.4-eelinux.orig/gcc/config/mips/mips.c gcc-3.0.4-eelinux/gcc/config/mips/mips.c
--- gcc-3.0.4-eelinux.orig/gcc/config/mips/mips.c	Tue Feb 19 17:16:53 2002
+++ gcc-3.0.4-eelinux/gcc/config/mips/mips.c	Thu Mar  7 03:47:45 2002
@@ -234,6 +234,40 @@
    set this option if such an option is used. */
 const char *mips_explicit_type_size_string;
 
+/* Specify power of two alignment for loop starts, labels after barriers
+   and functions.  Also specify maximum fill/skip allowed to achieve those
+   alignments (in bytes).
+
+   These are strings filled in by the generic code with the user arguments,
+   they are parsed in OVERRIDE_OPTIONS, then never referenced again.  */
+char *mips_align_loops_string;
+char *mips_max_skip_loops_string;
+char *mips_align_jumps_string;
+char *mips_max_skip_jumps_string;
+char *mips_align_funcs_string;
+char *mips_max_skip_funcs_string;
+
+/* Specify power of two alignment for loop starts, labels after barriers
+   and functions.  Also specify maximum fill/skip allowed to achieve those
+   alignments (in bytes).
+
+   Once the above strings are parsed, the resulting values are placed in
+   these variables.  */
+int mips_align_loops;
+int mips_max_skip_loops;
+int mips_align_jumps;
+int mips_max_skip_jumps;
+int mips_align_funcs;
+int mips_max_skip_funcs;
+
+#ifdef DEFAULT_MIPS_ALIGNMENT
+int mips_alignment=DEFAULT_MIPS_ALIGNMENT;	/* biggest alignment bits */
+#else
+int mips_alignment=BIGGEST_ALIGNMENT;		/* biggest alignment bits */
+#endif
+const char * mips_no_align128_string;
+const char * mips_align128_string;
+
 /* Whether we are generating mips16 hard float code.  In mips16 mode
    we always set TARGET_SOFT_FLOAT; this variable is nonzero if
    -msoft-float was not specified by the user, which means that we
@@ -325,7 +359,7 @@
  "$f8",  "$f9",  "$f10", "$f11", "$f12", "$f13", "$f14", "$f15",
  "$f16", "$f17", "$f18", "$f19", "$f20", "$f21", "$f22", "$f23",
  "$f24", "$f25", "$f26", "$f27", "$f28", "$f29", "$f30", "$f31",
- "hi",   "lo",   "accum","$fcc0","$fcc1","$fcc2","$fcc3","$fcc4",
+ "lo",   "hi",   "accum","$fcc0","$fcc1","$fcc2","$fcc3","$fcc4",
  "$fcc5","$fcc6","$fcc7","$rap"
 };
 
@@ -342,7 +376,7 @@
   "$f8",  "$f9",  "$f10", "$f11", "$f12", "$f13", "$f14", "$f15",
   "$f16", "$f17", "$f18", "$f19", "$f20", "$f21", "$f22", "$f23",
   "$f24", "$f25", "$f26", "$f27", "$f28", "$f29", "$f30", "$f31",
-  "hi",   "lo",   "accum","$fcc0","$fcc1","$fcc2","$fcc3","$fcc4",
+  "lo",   "hi",   "accum","$fcc0","$fcc1","$fcc2","$fcc3","$fcc4",
   "$fcc5","$fcc6","$fcc7","$rap"
 };
 
@@ -365,7 +399,7 @@
   FP_REGS,	FP_REGS,	FP_REGS,	FP_REGS,
   FP_REGS,	FP_REGS,	FP_REGS,	FP_REGS,
   FP_REGS,	FP_REGS,	FP_REGS,	FP_REGS,
-  HI_REG,	LO_REG,		HILO_REG,	ST_REGS,
+  LO_REG,	HI_REG,		HILO_REG,	ST_REGS,
   ST_REGS,	ST_REGS,	ST_REGS,	ST_REGS,
   ST_REGS,	ST_REGS,	ST_REGS,	GR_REGS
 };
@@ -3904,6 +3938,20 @@
       cum->arg_words += (TARGET_64BIT ? 1 : 2);
       break;
 
+    case TImode:
+      if (!TARGET_ARG128BIT) {
+	      /* TImode arg will be splited into 2 or 4 reg */
+	      cum->gp_reg_found = 1;
+	      cum->arg_words += ((GET_MODE_SIZE (mode) + UNITS_PER_WORD - 1)
+				 / UNITS_PER_WORD);
+	      break;
+      }
+      /* The r5900 only may need a single general register to pass a
+       TImode value.  */
+      cum->gp_reg_found = 1;
+      cum->arg_words += 1;
+      break;
+
     case QImode:
     case HImode:
     case SImode:
@@ -4024,6 +4072,18 @@
       if (! TARGET_64BIT)
 	cum->arg_words += (cum->arg_words & 1);
       regbase = GP_ARG_FIRST;
+
+    case TImode:
+      if (!TARGET_ARG128BIT) {
+	      /* TImode arg will be splited into 2 or 4 reg */
+	      regbase = GP_ARG_FIRST;
+	      break;
+      }
+      /* The r5900 only may need a single general register to pass a
+       TImode value.  */
+      regbase = GP_ARG_FIRST;
+      break;
+
     }
 
   if (*arg_words >= (unsigned) MAX_ARGS_IN_REGISTERS)
@@ -4178,6 +4238,7 @@
      int named ATTRIBUTE_UNUSED;/* != 0 for normal args, == 0 for ... args */
 {
   if ((mode == BLKmode
+       || (mode == TImode && !TARGET_ARG128BIT)
        || GET_MODE_CLASS (mode) != MODE_COMPLEX_INT
        || GET_MODE_CLASS (mode) != MODE_COMPLEX_FLOAT)
       && cum->arg_words < (unsigned) MAX_ARGS_IN_REGISTERS
@@ -4815,9 +4876,11 @@
 	  || mips_abi == ABI_64))
     target_flags |= MASK_LONG64;
 
+#if MIPS_ABI_DEFAULT != ABI_32
   /* ??? This doesn't work yet, so don't let people try to use it.  */
   if (mips_abi == ABI_32)
     error ("The -mabi=32 support does not work yet.");
+#endif
 
 #else
   if (mips_abi_string)
@@ -4938,6 +5001,12 @@
 	}
     }
 
+  /* set target flag for r3900, r5400 and r5900 */
+  target_flags &= ~MASK_MIPS5900;
+
+  if (mips_arch == PROCESSOR_R5900)
+      target_flags |= MASK_MIPS5900;
+
   if (mips_abi != ABI_32 && mips_abi != ABI_O64)
     flag_pcc_struct_return = 0;
 
@@ -5124,7 +5193,13 @@
 	    temp = ((regno & 1) == 0 || size <= UNITS_PER_WORD);
 
 	  else if (FP_REG_P (regno))
-	    temp = ((TARGET_FLOAT64 || ((regno & 1) == 0))
+	    /*
+	     * Use odd FP regs for TARGET_SINGLE_FLOAT even if !TARGET_FLOAT64.
+	     * TARGET_SINGLE_FLOAT means the target FPU has 32 single precision
+	     * 32bit FP regs. In this case,  FP regs aren't coupled for double 
+	     * precision, and odd FP regs can be used to compute.
+	     */
+	    temp = ((TARGET_FLOAT64 || TARGET_SINGLE_FLOAT || ((regno & 1) == 0))
 		    && (class == MODE_FLOAT
 			|| class == MODE_COMPLEX_FLOAT
 			|| (TARGET_DEBUG_H_MODE && class == MODE_INT))
@@ -5147,6 +5222,100 @@
      initialized yet, so we can't use that here.  */
   gpr_mode = TARGET_64BIT ? DImode : SImode;
 
+  {
+    int min_align = 2;
+    int max_align = 15;
+    int min_max_skip = 0;
+    int max_max_skip = 32767;
+
+    /* Validate -malign-loops= value, or provide default */
+    if (mips_align_loops_string)
+      {
+	if (TARGET_MIPS16)
+	  error ("the combination of -mips16 and -malign-loops is not supported");
+	mips_align_loops = atoi (mips_align_loops_string);
+	if (mips_align_loops < min_align || mips_align_loops > max_align)
+	  error ("-malign-loops=%d is not between %d and %d",
+	         mips_align_loops, min_align, max_align);
+      }
+    else
+      {
+	if (TARGET_MIPS16)
+	  mips_align_loops = 0;
+	else
+	  mips_align_loops = DEFAULT_LOOP_ALIGN;
+      }
+
+    /* Validate -malign-jumps= value, or provide default */
+    if (mips_align_jumps_string)
+      {
+	mips_align_jumps = atoi (mips_align_jumps_string);
+	if (mips_align_jumps < min_align || mips_align_jumps > max_align)
+	  error ("-malign-jumps=%d is not between %d and %d",
+	         mips_align_jumps, min_align, min_align);
+      }
+    else
+      mips_align_jumps = DEFAULT_JUMP_ALIGN;
+
+    /* Validate -malign-functions= value, or provide default */
+    if (mips_align_funcs_string)
+      {
+	mips_align_funcs = atoi (mips_align_funcs_string);
+	if (mips_align_funcs < min_align || mips_align_funcs > max_align)
+	  error ("-malign-functions=%d is not between %d and %d",
+	         mips_align_funcs, min_align, max_align);
+      }
+    else
+      mips_align_funcs = DEFAULT_FUNCTION_ALIGN;
+
+    /* Validate -mmax-skip-loops= value, or provide default */
+    if (mips_max_skip_loops_string)
+      {
+	mips_max_skip_loops = atoi (mips_max_skip_loops_string);
+	if (mips_max_skip_loops < min_max_skip
+	    || mips_max_skip_loops > max_max_skip)
+	  error ("-mmax-skip-loops=%d is not between %d and %d",
+		 mips_max_skip_loops, min_max_skip, max_max_skip);
+      }
+    else
+      mips_max_skip_loops = DEFAULT_LOOP_MAX_SKIP;
+
+    /* Validate -mmax-skip-jumps= value, or provide default */
+    if (mips_max_skip_jumps_string)
+      {
+	mips_max_skip_jumps = atoi (mips_max_skip_jumps_string);
+	if (mips_max_skip_jumps < min_max_skip
+	    || mips_max_skip_jumps > max_max_skip)
+	  error ("-mmax-skip-jumps=%d is not between %d and %d",
+		 mips_max_skip_jumps, min_max_skip, max_max_skip);
+      }
+    else
+      mips_max_skip_jumps = DEFAULT_JUMP_MAX_SKIP;
+
+    /* Validate -mmax-skip-functions= value, or provide default */
+    if (mips_max_skip_funcs_string)
+      {
+	mips_max_skip_funcs = atoi (mips_max_skip_funcs_string);
+	if (mips_max_skip_funcs < min_max_skip
+	    || mips_max_skip_funcs > max_max_skip)
+	  error ("-mmax-skip-functions=%d is not between %d and %d",
+		 mips_max_skip_funcs, min_max_skip, max_max_skip);
+      }
+    else
+      mips_max_skip_funcs = DEFAULT_FUNCTION_MAX_SKIP;
+  }
+
+#ifdef DEFAULT_MIPS_ALIGNMENT
+  if (mips_align128_string != NULL) {
+	/* -malign128 */
+  	mips_alignment=128;
+  } 
+  if (mips_no_align128_string != NULL) {
+	/* -mno-align128 */
+  	mips_alignment=64;
+  }
+#endif
+
   /* Provide default values for align_* for 64-bit targets.  */
   if (TARGET_64BIT && !TARGET_MIPS16)
     {
@@ -6801,7 +6970,8 @@
 #endif
   long tsize = current_frame_info.total_size;
 
-  ASM_OUTPUT_SOURCE_FILENAME (file, DECL_SOURCE_FILE (current_function_decl));
+  /* ASM_OUTPUT_SOURCE_FILENAME (file, DECL_SOURCE_FILE
+   * (current_function_decl)); */
 
 #ifdef SDB_DEBUGGING_INFO
   if (debug_info_level != DINFO_LEVEL_TERSE && write_symbols == SDB_DEBUG)
@@ -9119,6 +9289,216 @@
   return NULL_RTX;
 }
 
+/* On the R5900, we must ensure that the compiler never generates loops
+   that satisfy all of the following conditions:
+   
+   * a loop consists of less than equal to six instructions(includes
+     branch delay slot).
+   
+   * a loop contains only one conditional branch instruction at the
+     end of the loop.
+     
+   * a loop does not contain any other branch or jump instructions.
+
+   * a branch delay slot of the loop is not nop. ( EE#2.9 or later )
+
+   We need to do this because of a bug in the chip.
+
+   */
+/* turn FILL_BDSLOT_WITH_NOP on for EE#2.9 or later */
+#define FILL_BDSLOT_WITH_NOP
+
+#ifdef FILL_BDSLOT_WITH_NOP
+inline
+static int is_nop_insn(insn)
+	rtx insn;
+{
+	return (rtx_equal_p (insn, gen_nop ()));
+}
+#endif
+
+enum sequence_type {Jump, Reset, Otherwise};
+
+/* Detect if possible loop jump presents in the sequence */
+static enum sequence_type 
+detect_sequence_type (insn, count_p, jump_insn_p, seen_before, 
+			after_delayed_branch_sched)
+	rtx insn;
+	int *count_p;
+	rtx *jump_insn_p;
+	int *seen_before;
+	int after_delayed_branch_sched;
+{
+      int i;
+      int detect_later=0;
+
+      for (i = 0; i < XVECLEN (PATTERN (insn), 0); i++)
+	{
+	  rtx v_insn;
+	  v_insn = XVECEXP (PATTERN (insn), 0, i);
+	  switch (GET_CODE (v_insn))
+	    {
+	    case CODE_LABEL:
+	      seen_before [INSN_UID (v_insn)] = *count_p;
+	      break;
+	    case INSN:
+	      /* The attr_length may be bigger than acctual insn length.
+	    	 So don't use it in the after_delayed_branch_sched phase. */
+	      *count_p  += ( get_attr_length (insn) > 0 
+	            		&& !after_delayed_branch_sched ) 
+			    ?  get_attr_length (insn) : 4 ; 
+	      if (detect_later) {
+		/* inspect BD slot */
+#ifdef FILL_BDSLOT_WITH_NOP
+		if (is_nop_insn (PATTERN (v_insn)))
+	            return  Reset;
+#endif
+	        return  Jump;
+	      }
+	      break;
+	    case JUMP_INSN:
+	      *jump_insn_p = v_insn;
+	      detect_later = 1;
+	      break;
+	    case CALL_INSN:
+	      return  Reset;
+	      break;
+            default: break;
+	    }
+	}
+      if (detect_later) 
+        {
+	  /* No insn presents in BD slot. AS will fill it with nop. */
+	  return  Reset;
+        }
+      return Otherwise;
+}
+
+static void
+mips_r5900_lengthen_loops (first, after_delayed_branch_sched)
+  rtx first;
+  int after_delayed_branch_sched;
+{
+  rtx insn;
+  rtx this_jump_insn;
+  const int hazardous_distance = 6;
+  int n = 4;
+  int max_uid = get_max_uid ();
+  int *seen_before = alloca (sizeof seen_before[0] * max_uid);
+  int in_sequence = 0;
+  enum sequence_type result;
+      
+  bzero ((char *) seen_before, sizeof seen_before[0] * max_uid);
+      
+  for (insn = first; insn; insn = NEXT_INSN (insn))
+    {
+      in_sequence = 0;
+      switch (GET_CODE (insn))
+	{
+	case CODE_LABEL:
+	  seen_before [INSN_UID (insn)] = n;
+	  break;
+
+	case INSN:
+	  if (GET_CODE (PATTERN (insn)) != SEQUENCE ) 
+	    {
+	      /* The attr_length may be bigger than acctual insn length.
+	         So don't use it in the after_delayed_branch_sched phase. */
+	      n += ( get_attr_length (insn) > 0 
+	            && !after_delayed_branch_sched ) 
+		 ?  get_attr_length (insn) : 4 ; 
+	      break;
+	    }
+	  result = detect_sequence_type(insn, &n, &this_jump_insn, 
+				  seen_before, after_delayed_branch_sched);
+	  switch(result) 
+	    {
+	    case Reset:
+	      goto reset;
+	      break;
+	    case Jump:
+	      in_sequence=1;
+	      goto jump_insn;
+	      break;
+	    }
+	  break;
+
+	case JUMP_INSN:
+          this_jump_insn = insn;
+	  in_sequence=0;
+        jump_insn:
+	  if (condjump_p (this_jump_insn))
+	    {
+	      rtx target = condjump_label (this_jump_insn);
+
+	      if (seen_before [INSN_UID (XEXP (target, 0))])
+		{
+		  int distance 
+		    = (n - seen_before [INSN_UID (XEXP (target, 0))]) >> 2;
+
+#ifdef FILL_BDSLOT_WITH_NOP
+		  if (!in_sequence) 
+		    {
+		    /* try to insert one nop before jump 
+		     * if distance is in hazardous_distance */
+
+	 	    if  ( distance <=  hazardous_distance )
+		      {
+		        rtx prev_insn = PREV_INSN (this_jump_insn);
+		        while ( prev_insn && ( GET_CODE (prev_insn) != INSN ))
+			    prev_insn =  PREV_INSN (prev_insn);
+			if (prev_insn && ! is_nop_insn (PATTERN (prev_insn)))
+			      emit_insn_before (gen_nop (), this_jump_insn);
+
+		      }
+		    }
+		  else 
+		    {
+		      if ( distance <= hazardous_distance ) 
+		        {
+	     	          for (; distance <= hazardous_distance; distance++) 
+		            emit_insn_before (gen_nop(), insn);
+		        }
+		    }
+#else
+		  for (; distance <= hazardous_distance; distance++)
+		    {
+		      if (after_delayed_branch_sched)
+		        emit_insn_before (gen_nop(), insn);
+		      else
+		        emit_insn_before (gen_nop_internal (), insn);
+		    }
+#endif
+		}
+	    }
+
+	  /* Falls through */
+
+	case CALL_INSN:
+	reset:
+	  bzero ((char *) seen_before, sizeof seen_before[0] * max_uid);
+	  break;
+	    
+	default:
+	  break;
+	}
+    }
+}
+ 
+/* Exported to toplev.c.
+
+   Do a final pass over the function, just before rtl to asm conversion
+   (after "delayed branch scheduling" and "shorten jump").  */
+
+void
+machine_dependent_reorg_final (first)
+     rtx first;
+{
+	if (TARGET_MIPS5900 &&  !TARGET_NO_LENGTHEN_LOOP)
+		mips_r5900_lengthen_loops (first,1);
+}
+
+
 /* Exported to toplev.c.
 
    Do a final pass over the function, just before delayed branch
@@ -9135,6 +9515,13 @@
   if (! TARGET_MIPS16)
     return;
 
+#ifdef FILL_BDSLOT_WITH_NOP
+/* To lengthen short loop should be done 
+		after "delayed branch scheduling" again */
+  if (TARGET_MIPS5900 &&  !TARGET_NO_LENGTHEN_LOOP)
+    mips_r5900_lengthen_loops (first,0);
+#endif
+
   /* If $gp is used, try to remove stores, and replace loads with
      copies from $gp.  */
   if (optimize)
@@ -9437,22 +9824,30 @@
 	{
 	case GTU:
 	  code = NE;
+          comp = "ne";
+          inverted_comp = "eq";
 	  break;
 
 	case LEU:
 	  code = EQ;
+          comp = "eq";
+          inverted_comp = "ne";
 	  break;
 
 	case GEU:
 	  /* A condition which will always be true.  */
 	  code = EQ;
 	  op1 = "%.";
+          comp = "eq";
+          inverted_comp = "ne";
 	  break;
 
 	case LTU:
 	  /* A condition which will always be false. */
 	  code = NE;
 	  op1 = "%.";
+          comp = "ne";
+          inverted_comp = "eq";
 	  break;
 
 	default:
@@ -9717,6 +10112,8 @@
     case '5':
       if (!strcmp (p, "5000") || !strcmp (p, "5k") || !strcmp (p, "5K"))
         cpu = PROCESSOR_R5000;
+      else if (!strcmp (p, "5900"))
+        cpu = PROCESSOR_R5900;
       break;
 
     case '6':
@@ -9743,3 +10140,4 @@
 
   return cpu;
 }
+
diff -urN gcc-3.0.4-eelinux.orig/gcc/config/mips/mips.h gcc-3.0.4-eelinux/gcc/config/mips/mips.h
--- gcc-3.0.4-eelinux.orig/gcc/config/mips/mips.h	Tue Feb 19 17:16:53 2002
+++ gcc-3.0.4-eelinux/gcc/config/mips/mips.h	Thu Mar  7 03:47:45 2002
@@ -67,6 +67,7 @@
   PROCESSOR_R4600,
   PROCESSOR_R4650,
   PROCESSOR_R5000,
+  PROCESSOR_R5900,
   PROCESSOR_R8000
 };
 
@@ -162,6 +163,9 @@
 extern struct rtx_def *embedded_pic_fnaddr_rtx;	/* function address */
 extern int mips_string_length;		/* length of strings for mips16 */
 extern struct rtx_def *mips16_gp_pseudo_rtx; /* psuedo reg holding $gp */
+extern int mips_alignment;			/* max alignment bits */
+extern const char * mips_align128_string;	/* for -malign128 */
+extern const char * mips_no_align128_string;	/* for -mno-align128 */
 
 /* Functions to change what output section we are using.  */
 extern void		rdata_section PARAMS ((void));
@@ -217,8 +221,15 @@
 #define MASK_UNINIT_CONST_IN_RODATA \
 			   0x01000000	/* Store uninitialized
 					   consts in rodata */
+#define MASK_MIPS5900	   0x02000000	/* r5900 port */
 
 					/* Debug switches, not documented */
+
+#define MASK_NO_LENGTHEN_LOOP 0x10000000 /* Disable r5900 legthen loop */
+#define MASK_ARG128BIT	0x20000000	/* Use r5900's 128bit gp reg 
+							for TImode arg */
+#define MASK_5900REG_CODE 0x40000000	/* Generate r5900 specfic reg code */
+
 #define MASK_DEBUG	0		/* unused */
 #define MASK_DEBUG_A	0		/* don't allow <label>($reg) addrs */
 #define MASK_DEBUG_B	0		/* GO_IF_LEGITIMATE_ADDRESS debug */
@@ -245,6 +256,18 @@
 /* generate mips 3900 insns */
 #define TARGET_MIPS3900         (target_flags & MASK_MIPS3900)
 
+/* Generate mips 5900 instructions.  */
+#define TARGET_MIPS5900		(target_flags & MASK_MIPS5900)
+
+/* Disable r5900 lengthen loop */
+#define	TARGET_NO_LENGTHEN_LOOP	(target_flags & MASK_NO_LENGTHEN_LOOP)
+
+/* Generate mips 5900 spcific regs instructions.: not yet implemented  */
+#define GENERATE_MIPS5900_REG_CODE (target_flags & MASK_5900REG_CODE)
+
+/* Pass TImode value use 128bit gp reg. : not yet implemented */
+#define TARGET_ARG128BIT	(target_flags & MASK_ARG128BIT)
+
 					/* Mips vs. GNU assembler */
 #define TARGET_GAS		(target_flags & MASK_GAS)
 #define TARGET_MIPS_AS		(!TARGET_GAS)
@@ -430,6 +453,8 @@
      N_("Optimize for 4650")},						\
   {"3900",		  MASK_MIPS3900,				\
      N_("Optimize for 3900")},						\
+  {"5900",		  MASK_MIPS5900,				\
+     "Optimize for 5900"},						\
   {"check-zero-division",-MASK_NO_CHECK_ZERO_DIV,			\
      N_("Trap on integer divide by zero")},				\
   {"no-check-zero-division", MASK_NO_CHECK_ZERO_DIV,			\
@@ -458,6 +483,8 @@
      NULL},								\
   {"debugi",		  MASK_DEBUG_I,					\
      NULL},								\
+  {"no-lengthen-loop",	  MASK_NO_LENGTHEN_LOOP,			\
+     "Disable lengthen loop for r5900"},				\
   {"",			  (TARGET_DEFAULT				\
 			   | TARGET_CPU_DEFAULT				\
 			   | TARGET_ENDIAN_DEFAULT),			\
@@ -573,6 +600,12 @@
       N_("Use mips16 entry/exit psuedo ops")},				\
   { "no-mips16", &mips_no_mips16_string,				\
       N_("Don't use MIPS16 instructions")},				\
+  { "align-loops=",	&mips_align_loops_string },			\
+  { "align-jumps=",	&mips_align_jumps_string },			\
+  { "align-functions=",	&mips_align_funcs_string },			\
+  { "max-skip-loops=",	&mips_max_skip_loops_string },			\
+  { "max-skip-jumps=",	&mips_max_skip_jumps_string },			\
+  { "max-skip-functions=",	&mips_max_skip_funcs_string },		\
   { "explicit-type-size", &mips_explicit_type_size_string,		\
       NULL},								\
 }
@@ -580,11 +613,13 @@
 /* This is meant to be redefined in the host dependent files.  */
 #define SUBTARGET_TARGET_OPTIONS
 
-#define GENERATE_BRANCHLIKELY  (!TARGET_MIPS16 && (TARGET_MIPS3900 || ISA_HAS_BRANCHLIKELY))
+#define GENERATE_BRANCHLIKELY  (!TARGET_MIPS16 && (TARGET_MIPS3900 	\
+				|| TARGET_MIPS5900 || (mips_isa >= 2)))
 
 /* Generate three-operand multiply instructions for both SImode and DImode.  */
-#define GENERATE_MULT3         (TARGET_MIPS3900				\
-				&& !TARGET_MIPS16)
+#define GENERATE_MULT3         ((TARGET_MIPS3900				\
+				 || TARGET_MIPS5900)				\
+ 				&& !TARGET_MIPS16)
 
 /* Macros to decide whether certain features are available or not,
    depending on the instruction set architecture level.  */
@@ -604,7 +639,7 @@
 				 )
 
 /* ISA has just the integer condition move instructions (movn,movz) */
-#define ISA_HAS_INT_CONDMOVE     0
+#define ISA_HAS_INT_CONDMOVE     (TARGET_MIPS5900)
 
 
 
@@ -791,7 +826,7 @@
 /* GAS_ASM_SPEC is passed when using gas, rather than the MIPS
    assembler.  */
 
-#define GAS_ASM_SPEC "%{mcpu=*} %{m4650} %{mmad:-m4650} %{m3900} %{v} %{mgp32} %{mgp64}"
+#define GAS_ASM_SPEC "%{mcpu=*} %{m4650} %{mmad:-m4650} %{m3900} %{m5900} %{v} %{mgp32} %{mgp64}"
 
 /* TARGET_ASM_SPEC is used to select either MIPS_AS_ASM_SPEC or
    GAS_ASM_SPEC as the default, depending upon the value of
@@ -1391,7 +1426,8 @@
 #define PARM_BOUNDARY (TARGET_64BIT ? 64 : 32)
 
 /* Allocation boundary (in *bits*) for the code of a function.  */
-#define FUNCTION_BOUNDARY 32
+#define FUNCTION_BOUNDARY (1 << (mips_align_funcs + 3))
+#define FUNCTION_BOUNDARY_MAX_SKIP (mips_max_skip_funcs)
 
 /* Alignment of field after `int : 0' in a structure.  */
 #define EMPTY_FIELD_BOUNDARY 32
@@ -1407,6 +1443,51 @@
    when given unaligned data.  */
 #define STRICT_ALIGNMENT 1
 
+/* Align loop starts for optimal branching.  */
+#define LOOP_ALIGN(LABEL) (mips_align_loops)
+#define LOOP_ALIGN_MAX_SKIP (mips_max_skip_loops)
+
+/* This is how to align an instruction for optimal branching. */
+#define LABEL_ALIGN_AFTER_BARRIER(LABEL) (mips_align_jumps)
+#define LABEL_ALIGN_AFTER_BARRIER_MAX_SKIP (mips_max_skip_jumps)
+
+#ifndef DEFAULT_LOOP_ALIGN
+#define DEFAULT_LOOP_ALIGN 2
+#endif
+
+#ifndef DEFAULT_JUMP_ALIGN
+#define DEFAULT_JUMP_ALIGN 2
+#endif
+
+#ifndef DEFAULT_FUNCTION_ALIGN
+#define DEFAULT_FUNCTION_ALIGN 2
+#endif
+
+#ifndef DEFAULT_LOOP_MAX_SKIP
+#define DEFAULT_LOOP_MAX_SKIP 0
+#endif
+
+#ifndef DEFAULT_JUMP_MAX_SKIP
+#define DEFAULT_JUMP_MAX_SKIP 0
+#endif
+
+#ifndef DEFAULT_FUNCTION_MAX_SKIP
+#define DEFAULT_FUNCTION_MAX_SKIP 0
+#endif
+
+extern char *mips_align_loops_string;
+extern char *mips_align_jumps_string;
+extern char *mips_align_funcs_string;
+extern int mips_align_loops;
+extern int mips_align_jumps;
+extern int mips_align_funcs;
+extern char *mips_max_skip_loops_string;
+extern char *mips_max_skip_jumps_string;
+extern char *mips_max_skip_funcs_string;
+extern int mips_max_skip_loops;
+extern int mips_max_skip_jumps;
+extern int mips_max_skip_funcs;
+
 /* Define this if you wish to imitate the way many other C compilers
    handle alignment of bitfields and the structures that contain
    them.
@@ -1593,8 +1674,8 @@
 #define RAP_REG_NUM   75
 
 #define AT_REGNUM	(GP_REG_FIRST + 1)
-#define HI_REGNUM	(MD_REG_FIRST + 0)
-#define LO_REGNUM	(MD_REG_FIRST + 1)
+#define LO_REGNUM	(MD_REG_FIRST + 0)
+#define HI_REGNUM	(MD_REG_FIRST + 1)
 #define HILO_REGNUM	(MD_REG_FIRST + 2)
 
 /* FPSW_REGNUM is the single condition code used if mips_isa < 4.  If
@@ -1771,12 +1852,12 @@
   M16_T_REGS,			/* mips16 registers plus T register */
   GR_REGS,			/* integer registers */
   FP_REGS,			/* floating point registers */
-  HI_REG,			/* hi register */
   LO_REG,			/* lo register */
+  HI_REG,			/* hi register */
   HILO_REG,			/* hilo register pair for 64 bit mode mult */
   MD_REGS,			/* multiply/divide registers (hi/lo) */
-  HI_AND_GR_REGS,		/* union classes */
   LO_AND_GR_REGS,
+  HI_AND_GR_REGS,		/* union classes */
   HILO_AND_GR_REGS,
   ST_REGS,			/* status registers (fp status) */
   ALL_REGS,			/* all registers */
@@ -1800,12 +1881,12 @@
   "M16_T_REGS",								\
   "GR_REGS",								\
   "FP_REGS",								\
-  "HI_REG",								\
   "LO_REG",								\
+  "HI_REG",								\
   "HILO_REG",								\
   "MD_REGS",								\
-  "HI_AND_GR_REGS",							\
   "LO_AND_GR_REGS",							\
+  "HI_AND_GR_REGS",							\
   "HILO_AND_GR_REGS",							\
   "ST_REGS",								\
   "ALL_REGS"								\
@@ -1831,8 +1912,8 @@
   { 0x010300fc, 0x00000000, 0x00000000 },	/* mips16 and T regs */ \
   { 0xffffffff, 0x00000000, 0x00000000 },	/* integer registers */	\
   { 0x00000000, 0xffffffff, 0x00000000 },	/* floating registers*/	\
-  { 0x00000000, 0x00000000, 0x00000001 },	/* hi register */	\
-  { 0x00000000, 0x00000000, 0x00000002 },	/* lo register */	\
+  { 0x00000000, 0x00000000, 0x00000001 },	/* lo register */	\
+  { 0x00000000, 0x00000000, 0x00000002 },	/* hi register */	\
   { 0x00000000, 0x00000000, 0x00000004 },	/* hilo register */	\
   { 0x00000000, 0x00000000, 0x00000003 },	/* mul/div registers */	\
   { 0xffffffff, 0x00000000, 0x00000001 },	/* union classes */     \
@@ -2057,11 +2138,14 @@
 #define CLASS_UNITS(mode, size)						\
   ((GET_MODE_SIZE (mode) + (size) - 1) / (size))
 
+/* If TARGET_SINGLE_FLOAT, FP regs aren't coupled odd-even pair. */
 #define CLASS_MAX_NREGS(CLASS, MODE)					\
   ((CLASS) == FP_REGS							\
    ? (TARGET_FLOAT64							\
       ? CLASS_UNITS (MODE, 8)						\
-      : 2 * CLASS_UNITS (MODE, 8))					\
+        : ( TARGET_SINGLE_FLOAT						\
+            ? CLASS_UNITS (MODE, 4)					\
+      : 2 * CLASS_UNITS (MODE, 8)))					\
    : CLASS_UNITS (MODE, UNITS_PER_WORD))
 
 /* If defined, gives a class of registers that cannot be used as the
@@ -2601,13 +2685,14 @@
   fprintf (FILE, "\t.set\tnoat\n");					\
   fprintf (FILE, "\tmove\t%s,%s\t\t# save current return address\n",	\
 	   reg_names[GP_REG_FIRST + 1], reg_names[GP_REG_FIRST + 31]);	\
-  fprintf (FILE, "\tjal\t_mcount\n");					\
   fprintf (FILE,							\
 	   "\t%s\t%s,%s,%d\t\t# _mcount pops 2 words from  stack\n",	\
 	   TARGET_64BIT ? "dsubu" : "subu",				\
 	   reg_names[STACK_POINTER_REGNUM],				\
 	   reg_names[STACK_POINTER_REGNUM],				\
 	   Pmode == DImode ? 16 : 8);					\
+  fprintf (FILE, "\tjal\t_mcount\n");					\
+  fprintf (FILE, "\tnop\n");						\
   fprintf (FILE, "\t.set\treorder\n");					\
   fprintf (FILE, "\t.set\tat\n");					\
 }
@@ -3504,6 +3589,8 @@
 	return COSTS_N_INSNS (17);					\
       else if (mips_tune == PROCESSOR_R5000)				\
 	return COSTS_N_INSNS (5);					\
+      else if (mips_tune == PROCESSOR_R5900)				\
+	return (xmode == SImode ? COSTS_N_INSNS (3) : COSTS_N_INSNS (30));\
       else								\
 	return COSTS_N_INSNS (10);					\
     }									\
@@ -3545,6 +3632,8 @@
       return COSTS_N_INSNS (38);					\
     else if (mips_tune == PROCESSOR_R5000)				\
       return COSTS_N_INSNS (36);					\
+    else if (mips_tune == PROCESSOR_R5900)				\
+      return COSTS_N_INSNS (30);					\
     else								\
       return COSTS_N_INSNS (69);					\
 									\
@@ -3697,6 +3786,9 @@
 #define ADJUST_INSN_LENGTH(INSN, LENGTH) \
   ((LENGTH) = mips_adjust_insn_length ((INSN), (LENGTH)))
 
+/* The r5900 is a dual issue machine.  */
+#undef ISSUE_RATE
+#define ISSUE_RATE ((TARGET_MIPS5900) ? 2 : 1)
 
 /* Optionally define this if you have added predicates to
    `MACHINE.c'.  This macro is called within an initializer of an
@@ -3906,7 +3998,7 @@
   "$f8",  "$f9",  "$f10", "$f11", "$f12", "$f13", "$f14", "$f15",	\
   "$f16", "$f17", "$f18", "$f19", "$f20", "$f21", "$f22", "$f23",	\
   "$f24", "$f25", "$f26", "$f27", "$f28", "$f29", "$f30", "$f31",	\
-  "hi",   "lo",   "accum","$fcc0","$fcc1","$fcc2","$fcc3","$fcc4",	\
+  "lo",   "hi",   "accum","$fcc0","$fcc1","$fcc2","$fcc3","$fcc4",	\
   "$fcc5","$fcc6","$fcc7","$rap"					\
 }
 
@@ -4382,6 +4474,13 @@
 #define ASM_OUTPUT_ALIGN(STREAM,LOG)					\
   fprintf (STREAM, "\t.align\t%d\n", (LOG))
 
+#ifdef HAVE_GAS_MAX_SKIP_P2ALIGN
+#define ASM_OUTPUT_MAX_SKIP_ALIGN(FILE,LOG,MAX_SKIP) \
+  if ((LOG)!=0) \
+    if ((MAX_SKIP)==0) fprintf ((FILE), "\t.p2align %d\n", (LOG)); \
+    else fprintf ((FILE), "\t.p2align %d,,%d\n", (LOG), (MAX_SKIP))
+#endif
+
 /* This is how to output an assembler line to advance the location
    counter by SIZE bytes.  */
 
@@ -4625,6 +4724,9 @@
 /* In mips16 mode, we need to look through the function to check for
    PC relative loads that are out of range.  */
 #define MACHINE_DEPENDENT_REORG(X) machine_dependent_reorg (X)
+
+/* For r5900, we need to lenghten short loop */
+#define MACHINE_DEPENDENT_REORG_FINAL(X) machine_dependent_reorg_final (X)
 
 /* We need to use a special set of functions to handle hard floating
    point code in mips16 mode.  */
diff -urN gcc-3.0.4-eelinux.orig/gcc/config/mips/t-eelinux gcc-3.0.4-eelinux/gcc/config/mips/t-eelinux
--- gcc-3.0.4-eelinux.orig/gcc/config/mips/t-eelinux	Wed Dec 31 18:00:00 1969
+++ gcc-3.0.4-eelinux/gcc/config/mips/t-eelinux	Thu Mar  7 03:47:25 2002
@@ -0,0 +1,77 @@
+# Suppress building libgcc1.a, since the MIPS compiler port is complete
+# and does not need anything from libgcc1.a.
+## LIBGCC1 =
+## CROSS_LIBGCC1 =
+###### from t-r5900
+# Suppress building libgcc1.a, since the MIPS compiler port is complete
+# and does not need anything from libgcc1.a.
+LIBGCC1 =
+CROSS_LIBGCC1 =
+
+# We must build libgcc2.a with -G 0, in case the user wants to link
+# without the $gp register.
+TARGET_LIBGCC2_CFLAGS = -G 0
+
+# We want fine grained libraries.
+# fp-bit.c and dp-bit.c are really part of libgcc1, 
+# but this will cause them to be
+# built correctly, so... [taken from t-sparclite]
+FPBIT = fp-bit.c
+DPBIT = dp-bit.c
+LIB2FUNCS_EXTRA = mips-bb-helper.asm ee-perfcounter.c 
+
+mips-bb-helper.asm:
+	rm -f mips-bb-helper.asm
+	ln -s $(srcdir)/config/mips/mips-bb-helper.asm mips-bb-helper.asm
+
+ee-perfcounter.c:
+	rm -f ee-perfcounter.c
+	ln -s $(srcdir)/config/mips/ee-perfcounter.c  ee-perfcounter.c
+
+
+dp-bit.c: $(srcdir)/config/fp-bit.c
+	echo '#ifdef __MIPSEL__' > dp-bit.c
+	echo '#define FLOAT_BIT_ORDER_MISMATCH' >> dp-bit.c
+	echo '#endif' >> dp-bit.c
+	echo '#define US_SOFTWARE_GOFAST' >> dp-bit.c
+	cat $(srcdir)/config/fp-bit.c >> dp-bit.c
+
+fp-bit.c: $(srcdir)/config/fp-bit.c
+	echo '#define FLOAT' > fp-bit.c
+	echo '#ifdef __MIPSEL__' >> fp-bit.c
+	echo '#define FLOAT_BIT_ORDER_MISMATCH' >> fp-bit.c
+	echo '#endif' >> fp-bit.c
+	echo '#define US_SOFTWARE_GOFAST' >> fp-bit.c
+	cat $(srcdir)/config/fp-bit.c >> fp-bit.c
+
+MULTILIB_OPTIONS = msoft-float
+MULTILIB_DIRNAMES = soft-float
+
+LIBGCC = stmp-multilib
+INSTALL_LIBGCC = install-multilib
+
+#
+# TImode runtime support
+#
+LIBGCC_TIMODE_SRC = $(srcdir)/config/mips/libgcc2-timode.c
+TIMODE_FUNCS_LIST = \
+	ashlti3		\
+	ashrti3		\
+	cmpti2		\
+	divti3		\
+	ffsti2		\
+	fixdfti		\
+	fixunsdfti	\
+	floattidf	\
+	floattisf	\
+	lshrti3		\
+	modti3		\
+	multi3		\
+	negti2		\
+	ucmpti2		\
+	udivti3		\
+	umodti3
+
+
+LIB2FUNCS_TI = $(TIMODE_FUNCS_LIST)
+
diff -urN gcc-3.0.4-eelinux.orig/gcc/config/mips/t-linux gcc-3.0.4-eelinux/gcc/config/mips/t-linux
--- gcc-3.0.4-eelinux.orig/gcc/config/mips/t-linux	Wed Dec 31 18:00:00 1969
+++ gcc-3.0.4-eelinux/gcc/config/mips/t-linux	Thu Mar  7 03:47:25 2002
@@ -0,0 +1,15 @@
+# Suppress building libgcc1.a, since the MIPS compiler port is complete
+# and does not need anything from libgcc1.a.
+## LIBGCC1 =
+## CROSS_LIBGCC1 =
+
+# We must build libgcc2.a with -G 0, in case the user wants to link
+# without the $gp register.
+TARGET_LIBGCC2_CFLAGS = -G 0
+
+LIB2FUNCS_EXTRA = mips-bb-helper.asm 
+
+mips-bb-helper.asm:
+	rm -f mips-bb-helper.asm
+	ln -s $(srcdir)/config/mips/mips-bb-helper.asm mips-bb-helper.asm
+
